package interfaz;

import javax.swing.JPanel;
import java.awt.Frame;
import java.awt.BorderLayout;
import javax.swing.JDialog;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import java.awt.GridBagConstraints;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import negocio.BloqueConstructivo;
import negocio.Plantilla;
import negocio.Proyecto;
import negocio.VistaPlantilla;

import org.hibernate.Session;
import org.hibernate.Transaction;

import persistencia.UtilidadHibernate;

import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.awt.Color;
import javax.swing.BorderFactory;
import java.awt.Dimension;

public class NuevaVista extends JDialog {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JPanel jPanel1 = null;

	private JButton jButton = null;

	private JLabel jLabel = null;

	private JTextField jTextField = null;
	
	public MantenimientoVista padreMantenimientoVista = null;
	
	private boolean actualizar;

	/**
	 * @param owner
	 */
	public NuevaVista(MantenimientoVista owner, boolean a) {
		super(owner);
		padreMantenimientoVista=owner;
		actualizar = a;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 250);
		this.setModal(true);
		if(!actualizar){
			if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
				this.setTitle("Nueva vista");
			else
				this.setTitle("New view");
		}
		else{
			if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
				this.setTitle("Modificar vista");
			else
				this.setTitle("Modify view");
		}
		this.setContentPane(getJContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowOpened(java.awt.event.WindowEvent e) {
				if (actualizar){
					int elemento = padreMantenimientoVista.jList.getSelectedIndex();	
					VistaPlantilla vista = (VistaPlantilla) padreMantenimientoVista.modelo.getElementAt(elemento);
					jTextField.setText(vista.getNombre());
				}
			}
		});
	}

	
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.EAST);
			jContentPane.add(getJPanel1(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new FlowLayout());
			jPanel.setBackground(SystemColor.controlHighlight);
			jPanel.setBorder(BorderFactory.createMatteBorder(0, 1, 0, 0, Color.lightGray));
			jPanel.add(getJButton(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.anchor = GridBagConstraints.WEST;
			gridBagConstraints1.insets = new Insets(0, 5, 0, 20);
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(0, 20, 0, 0);
			gridBagConstraints.gridy = 0;
			jLabel = new JLabel();
			if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
				jLabel.setText("Nombre:");
			else
				jLabel.setText("Name:");
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setBackground(new Color(238, 238, 238));
			jPanel1.add(jLabel, gridBagConstraints);
			jPanel1.add(getJTextField(), gridBagConstraints1);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
				jButton.setText("Aceptar");
			else
				jButton.setText("Accept");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String nombre;
						
					if (!actualizar){
						try{
							if((nombre=jTextField.getText().trim()).length()<=0)
								if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
									throw new Exception("El nombre está vacío");
								else
									throw new Exception("The name is empty");
							else{
								//Creamos la vista
								VistaPlantilla vista = new VistaPlantilla();
								vista.setNombre(nombre);
								int idelemento = padreMantenimientoVista.padrePrincipal.jList.getSelectedIndex();
								Plantilla plantilla = (Plantilla) padreMantenimientoVista.padrePrincipal.modelo.getElementAt(idelemento);
								
								vista.setPlantilla(plantilla);
								
								//Comprobamos que el nombre de la vista no se repita en la base de datos.
								Session session=null;
								
								session = UtilidadHibernate.getSessionFactory().openSession();
								
								Transaction tx = session.beginTransaction();

								List mensaje = session.createQuery("from VistaPlantilla where nombre ='"+nombre+"' AND id_plantilla ='"+plantilla.getIdPlantilla()+"'").list();
								if (mensaje.size() <= 0){

									//Convertimos los objetos en persistentes y los guardamos
									session.save(vista);

									tx.commit();

									padreMantenimientoVista.actualizaModelo();
									padreMantenimientoVista.EstadisticasNumeroVistas();
									padreMantenimientoVista.jList.setSelectedIndex(padreMantenimientoVista.modelo.getSize()-1);
									session.close();
									
									NuevaVista.this.dispose();
									
								}
								else{
									if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
										throw new Exception ("Error, ya existe una vista con ese nombre");
									else
										throw new Exception ("Error, There is already a view with that name");
								}
							}
						}	
						catch (Exception exp) {
							// TODO: handle exception
							JOptionPane.showMessageDialog(null, exp.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
						}
					}
					else{
						try{
							if((nombre=jTextField.getText().trim()).length()<=0){
								if (padreMantenimientoVista.padrePrincipal.idioma.equals("español"))
									throw new Exception("El nombre está vacío.");
								else
									throw new Exception("The name is empty.");
							}else{
								
								int elemento = padreMantenimientoVista.jList.getSelectedIndex();	
								VistaPlantilla vista = (VistaPlantilla) padreMantenimientoVista.modelo.getElementAt(elemento);
								vista.setNombre(jTextField.getText());
								
								//Creamos la sesión para almacenar el nombre del proyecto en la BD
								Session session=null;
								
								session = UtilidadHibernate.getSessionFactory().openSession();
								
								
								//Actualizamos dicha información en los bloques afectados.
								int idelemento = padreMantenimientoVista.padrePrincipal.jList.getSelectedIndex();
								Plantilla plantilla = (Plantilla) padreMantenimientoVista.padrePrincipal.modelo.getElementAt(idelemento);
	
								Transaction tx = session.beginTransaction();
	
								//Convertimos los objetos en persistentes y los guardamos
								session.update(vista);
								tx.commit();
		
								padreMantenimientoVista.actualizaModelo();
								
								session.close();
								//JOptionPane.showMessageDialog(null, "El proyecto se ha dado de alta correctamente, el responsable de proyecyo podrá modificarlos para añadirle los participantes y los participantes externos", "Información", JOptionPane.INFORMATION_MESSAGE);
								NuevaVista.this.dispose();
							}
						}	
						catch (Exception exp) {
							// TODO: handle exception
							JOptionPane.showMessageDialog(null, exp.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
						}
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
		}
		return jTextField;
	}

}
